//#include "colors.inc"
//                                
//                              
//                                
//camera {
//  location <0, 20, -3*12>
//  look_at <0, 12, 0>
//}
//
//
//light_source { <999, 999, -999> <1.3,1.3,1.3> }
//
//
//plane {
//  y, 0
//  texture {
//    pigment {
//      checker 
//        color Yellow*2
//        color White*2
//  } scale <5,1,5>
// }
//}
//
//plane {
//  y, 0 hollow
//  texture { pigment { SkyBlue*5 }
//  } translate <0,10000,0>
//}

// < sin(y)cos(x), sin(y)sin(x), cos(y) >
#macro SphToRec (rho, theta, phi) 
  rho*<sin(phi)*cos(theta), sin(phi)*sin(theta), cos(phi)> 
#end  
#declare TumbleStr = 0.93;
#declare TumbleCore = blob
  { threshold .15 
    cylinder
      { SphToRec(2.35,3.27,1.82),
        SphToRec(1.16,0.21,0.51), 0.113, TumbleStr }  
    cylinder
      { SphToRec(11.26,3.11,0.53),
        SphToRec(0.37,3.19,0.84) 0.209, TumbleStr }  
    cylinder
      { SphToRec(9.6,4.27,2.81),
        SphToRec(1.55,1.46,2.5) 0.073, TumbleStr }  
    cylinder
      { SphToRec(1.93,3.49,0.47),
        SphToRec(11.56,5.2,0.6) 0.035, TumbleStr }  
    cylinder
      { SphToRec(10.93,3.78,0.67),
        SphToRec(1.1,1.68,1.86) 0.322, TumbleStr }  
    cylinder
      { SphToRec(4.47,2.3,0.49),
        SphToRec(11.88,1.45,1.66) 0.214, TumbleStr }  
    cylinder
      { SphToRec(5.56,5.82,1.64),
        SphToRec(7.58,5.28,0.79) 0.123, TumbleStr }  
    cylinder
      { SphToRec(10.0,0.83,3.08),
        SphToRec(11.29,5.13,1.51) 0.072, TumbleStr }  
    cylinder
      { SphToRec(1.61,6.18,1.72),
        SphToRec(11.52,3.05,2.89) 0.065, TumbleStr }  
    cylinder
      { SphToRec(11.21,0.98,0.37),
        SphToRec(11.5,0.06,1.48) 0.259, TumbleStr }  
    cylinder
      { SphToRec(4.56,4.64,1.48),
        SphToRec(0.31,2.39,.084) 0.182, TumbleStr }  
    cylinder
      { SphToRec(2.24,2.3,3.11),
        SphToRec(4.6,3.55,2.55) 0.283, TumbleStr }  
    cylinder
      { SphToRec(8.46,6.07,2.86),
        SphToRec(7.89,0.72,1.89) 0.232, TumbleStr }  
    cylinder
      { SphToRec(3.36,5.35,0.53),
        SphToRec(6.28,0.87,2.59) 0.156, TumbleStr }  
    cylinder
      { SphToRec(5.72,5.75,3.01),
        SphToRec(5.88,3.02,3.03) 0.157, TumbleStr }  
    cylinder
      { SphToRec(3.03,0.16,2.44),
        SphToRec(3.65,3.04,1.35) 0.331, TumbleStr }  
    cylinder
      { SphToRec(11.12,1.05,2.84),
        SphToRec(3.32,2.78,1.75) 0.249, TumbleStr }  
    cylinder
      { SphToRec(4.46,3.9,2.29),
        SphToRec(6.83,0.8,2.12) 0.157, TumbleStr }  
    cylinder
      { SphToRec(3.52,4.79,2.85),
        SphToRec(9.07,3.1,0.28) 0.242, TumbleStr }  
    cylinder
      { SphToRec(9.76,6.12,3.03),
        SphToRec(8.39,1.67,0.54) 0.182, TumbleStr }  
    cylinder
      { SphToRec(7.65,3.72,2.57),
        SphToRec(7.86,1.74,0.23) 0.065, TumbleStr }  
    cylinder
      { SphToRec(9.96,2.75,1.75),
        SphToRec(6.72,0.22,0.88) 0.2, TumbleStr }  
    cylinder
      { SphToRec(0.85,1.18,1.59),
        SphToRec(10.36,6.05,0.53) 0.171, TumbleStr }  
    cylinder
      { SphToRec(6.41,5.17,1.09),
        SphToRec(3.64,5.16,0.14) 0.157, TumbleStr }  
    cylinder
      { SphToRec(5.28,4.91,3.07),
        SphToRec(10.22,5.04,2.25) 0.228, TumbleStr }
    cylinder
      { SphToRec(11.32,4.05,0.56), 
        SphToRec(10.13,4.64,1.45), 0.052, TumbleStr }
    cylinder
      { SphToRec(11.29,4.56,3.05), 
        SphToRec(10.82,3.23,1.67), 0.330, TumbleStr }
    cylinder
      { SphToRec(11.25,2.84,2.36), 
        SphToRec(10.43,0.57,1.99), 0.324, TumbleStr }
    cylinder
      { SphToRec(11.09,5.37,3.03), 
        SphToRec(10.53,1.1,0.53), 0.198, TumbleStr }
    cylinder
      { SphToRec(11.67,3.05,0.09),
        SphToRec(10.63,5.83,3.09), 0.257, TumbleStr }
    cylinder
      { SphToRec(11.8,4.12,0.57), 
        SphToRec(10.97,2.06,1.65), 0.248, TumbleStr }
    cylinder
      { SphToRec(11.79,4.26,0.08),
        SphToRec(10.37,0.8,1.42), 0.314, TumbleStr }
    cylinder
      { SphToRec(11.17,3.85,2.26),
        SphToRec(10.53,5.96,1.77), 0.294, TumbleStr }
    cylinder
      { SphToRec(11.95,2.1,2.27),
        SphToRec(10.21,5.00,2.55), 0.059, TumbleStr }
    cylinder
      { SphToRec(11.86,5.54,2.14),
        SphToRec(10.95,1.15,1.74), 0.192, TumbleStr }
    cylinder
      { SphToRec(11.73,3.48,0.82),
        SphToRec(10.63,0.03,2.44), 0.302, TumbleStr }
    cylinder
      { SphToRec(11.32,0.2,2.77),
        SphToRec(10.79,3.92,0.7), 0.042, TumbleStr }
    cylinder
      { SphToRec(11.24,4.42,0.05),
        SphToRec(10.83,2.96,0.73), 0.251, TumbleStr }
    cylinder
      { SphToRec(11.4,3.67,2.16),
        SphToRec(10.04,5.33,2.38), 0.156, TumbleStr }
    cylinder
      { SphToRec(11.48,5.11,0.75),
        SphToRec(10.14,2.35,0.74), 0.202, TumbleStr }
    cylinder
      { SphToRec(11.79,3.11,1.52),
        SphToRec(10.02,3.92,2.44), 0.056, TumbleStr }
    cylinder
      { SphToRec(11.0,4.04,0.42),
        SphToRec(10.59,0.46,0.67), 0.098, TumbleStr }
    cylinder
      { SphToRec(11.88,4.23,1.97),
        SphToRec(10.43,4.48,3.08), 0.105, TumbleStr }
    cylinder
      { SphToRec(11.34,2.31,2.88),
        SphToRec(10.28,3.4,0.64), 0.154, TumbleStr }
    cylinder
      { SphToRec(11.41,3.61,1.67),
        SphToRec(10.43,0.42,1.87), 0.289, TumbleStr }
    cylinder
      { SphToRec(11.63,3.15,2.38),
        SphToRec(10.53,5.56,2.7), 0.095, TumbleStr }
    cylinder
      { SphToRec(11.53,5.7,3.1),
        SphToRec(10.44,3.37,2.1), 0.315, TumbleStr }
    cylinder
      { SphToRec(11.6,4.11,2.07),
        SphToRec(10.99,1.43,2.66), 0.096, TumbleStr }
    cylinder
      { SphToRec(11.63,5.22,0.2),
        SphToRec(10.44,3.34,2.33), 0.299, TumbleStr }
    cylinder
      { SphToRec(11.28,6.26,1.55),
        SphToRec(10.74,4.85,1.75), 0.053, TumbleStr }
      
  }
  
#declare JesusCrown = union {
  
  #declare JCphi = pi;
  #while (JCphi>0) 
    #declare JCtheta = 0;
    #while (JCtheta<2*pi)
        cone { SphToRec(10.5,JCtheta+(sin(47*JCphi+235)/4),JCphi-(cos(87*JCphi+352)/5)), (0.1*(sin(3*JCphi)+cos(7*JCtheta))/2)+.15
               SphToRec(12,JCtheta-(cos(13*JCphi+532)/5),JCphi+(sin(113*JCphi+42)/4)), 0
                }
      #declare JCtheta=JCtheta+pi/5;
    #end
    #declare JCphi=JCphi-pi/10;
  #end 
 
}
#declare Tumbleweed = union {
//object { JesusCrown translate <0,12,0> }
//object { JesusCrown rotate <142,243,300> translate <0,12,0> }
//object { JesusCrown rotate <42,143,30> translate <0,12,0> }
  
object { TumbleCore translate <0,0,0> } //<0,12,0> }
object { TumbleCore rotate <200,150,150> } //translate <0,12,0> }
object { TumbleCore rotate <42,237,193> } //translate <0,12,0> }
//object { TumbleCore rotate <132,137,293> translate <0,12,0> } 
//object { TumbleCore rotate <132,137,93> translate <0,12,0> }
//object { TumbleCore rotate <273,69,133> translate <0,12,0> }
texture { 
  pigment { color DarkWood }
  //finish { phong 1  metallic diffuse 0.3 } 
}
}
